Index: admin/js/jquery/jquery.pageTabs.js
===================================================================
--- admin/js/jquery/jquery.pageTabs.js	(revision 3690)
+++ admin/js/jquery/jquery.pageTabs.js	(revision 3884)
@@ -1,7 +1,9 @@
+/*global jQuery, chainHandler */
+'use strict';
+
 (function($) {
-  'use strict';
 
   $.pageTabs = function(start_tab, opts) {
-    var defaults = {
+    const defaults = {
       containerClass: 'part-tabs',
       partPrefix: 'part-',
@@ -12,7 +14,7 @@
 
     $.pageTabs.options = $.extend({}, defaults, opts);
-    var active_tab = start_tab || '';
-    var hash = $.pageTabs.getLocationHash();
-    var subhash = $.pageTabs.getLocationSubhash();
+    let active_tab = start_tab || '';
+    const hash = $.pageTabs.getLocationHash();
+    const subhash = $.pageTabs.getLocationSubhash();
 
     if (hash !== undefined && hash) {
@@ -25,5 +27,5 @@
     createTabs();
 
-    $('ul li', '.' + $.pageTabs.options.containerClass).click(function(e) {
+    $('ul li', '.' + $.pageTabs.options.containerClass).click(function() {
       if ($(this).hasClass($.pageTabs.options.activeClass)) {
         return;
@@ -34,5 +36,5 @@
       $('.' + $.pageTabs.options.contentClass + '.active').removeClass('active').hide();
 
-      var part_to_activate = $('#' + $.pageTabs.options.partPrefix + getHash($(this).find('a').attr('href')));
+      const part_to_activate = $('#' + $.pageTabs.options.partPrefix + getHash($(this).find('a').attr('href')));
 
       part_to_activate.addClass('active').show();
@@ -45,5 +47,5 @@
     });
 
-    $(window).bind('hashchange onhashchange', function(e) {
+    $(window).bind('hashchange onhashchange', function() {
       $.pageTabs.clickTab($.pageTabs.getLocationHash());
     });
@@ -52,7 +54,7 @@
 
     if (subhash !== undefined) {
-      var elt = document.getElementById(subhash);
+      const elt = document.getElementById(subhash);
       // Tab displayed, now scroll to the sub-part if defined in original document.location (#tab.sub-part)
-      elt.scrollIntoView()
+      elt.scrollIntoView();
       // Give focus to the sub-part if possible
       $('#' + subhash).addClass('focus').focusout(function() {
@@ -65,7 +67,6 @@
   };
 
-  var createTabs = function createTabs() {
-    var lis = [],
-      li_class = '';
+  const createTabs = function createTabs() {
+    let lis = [];
 
     $('.' + $.pageTabs.options.contentClass).each(function() {
@@ -80,6 +81,6 @@
   };
 
-  var getHash = function getHash(href) {
-    var href = href || '';
+  const getHash = function getHash(href) {
+    href = href || '';
 
     return href.replace(/.*#/, '');
@@ -92,5 +93,5 @@
       // try to find anchor in a .multi-part div
       if ($('#' + tab).length == 1) {
-        var div_content = $('#' + tab).parents('.' + $.pageTabs.options.contentClass);
+        const div_content = $('#' + tab).parents('.' + $.pageTabs.options.contentClass);
         if (div_content.length == 1) {
           tab = div_content.attr('id').replace($.pageTabs.options.partPrefix, '');
@@ -110,10 +111,10 @@
   $.pageTabs.getLocationHash = function() {
     // Return the URL hash (without subhash — #hash[.subhash])
-    var h = getHash(document.location.hash).split('.');
+    const h = getHash(document.location.hash).split('.');
     return h[0];
   };
   $.pageTabs.getLocationSubhash = function() {
     // Return the URL subhash if present (without hash — #hash[.subhash])
-    var sh = getHash(document.location.hash).split('.');
+    const sh = getHash(document.location.hash).split('.');
     return sh[1];
   };
@@ -123,7 +124,7 @@
   this.each(function() {
     if (f) {
-      chainHandler(this, 'tabload', f)
+      chainHandler(this, 'tabload', f);
     } else {
-      var h = this.tabload;
+      const h = this.tabload;
       if (h) {
         h.apply(this);
@@ -139,5 +140,5 @@
       chainHandler(this, 'onetabload', f);
     } else {
-      var h = this.onetabload;
+      const h = this.onetabload;
       if (h != null) {
         h.apply(this);
Index: admin/js/meta-editor.js
===================================================================
--- admin/js/meta-editor.js	(revision 3706)
+++ admin/js/meta-editor.js	(revision 3880)
@@ -54,9 +54,9 @@
     });
 
-    var This = this;
+    const This = this;
 
     this.submit_button = $('<input type="button" value="ok" class="ib meta-helper" />');
     this.submit_button.click(function() {
-      var v = This.meta_dialog.val();
+      const v = This.meta_dialog.val();
       This.addMeta(v);
       return false;
@@ -72,5 +72,5 @@
 
   displayMetaList: function() {
-    var li;
+    let li;
     if (this.meta_list == undefined) {
       this.meta_list = $('<ul class="metaList"></ul>');
@@ -79,10 +79,10 @@
 
     if (this.post_id == false) {
-      var meta = this.splitMetaValues(this.meta_field.val());
+      const meta = this.splitMetaValues(this.meta_field.val());
 
       this.meta_list.empty();
-      for (var i = 0; i < meta.length; i++) {
+      for (let i = 0; i < meta.length; i++) {
         li = $('<li>' + meta[i] + '</li>');
-        var a_remove = $('<button type="button" class="metaRemove meta-helper"><img src="images/trash.png" alt="remove" /></button>');
+        const a_remove = $('<button type="button" class="metaRemove meta-helper"><img src="images/trash.png" alt="remove" /></button>');
         a_remove.get(0).caller = this;
         a_remove.get(0).meta_id = meta[i];
@@ -95,6 +95,6 @@
       }
     } else {
-      var This = this;
-      var params = {
+      const This = this;
+      const params = {
         f: 'getMeta',
         metaType: this.meta_type,
@@ -112,7 +112,7 @@
         This.meta_list.empty();
         data.find('meta').each(function() {
-          var meta_id = $(this).text();
+          const meta_id = $(this).text();
           li = $('<li><a href="' + This.meta_url + $(this).attr('uri') + '">' + meta_id + '</a></li>');
-          a_remove = $('<button type="button" class="metaRemove meta-helper"><img src="images/trash.png" alt="remove" /></button>');
+          const a_remove = $('<button type="button" class="metaRemove meta-helper"><img src="images/trash.png" alt="remove" /></button>');
           a_remove.get(0).caller = This;
           a_remove.get(0).meta_id = meta_id;
@@ -145,5 +145,5 @@
 
   showMetaList: function(list_type, target) {
-    var params = {
+    const params = {
       f: 'getMeta',
       metaType: this.meta_type,
@@ -155,9 +155,9 @@
     }
 
-    var This = this;
+    const This = this;
 
     $.get(this.service_uri, params, function(data) {
 
-      var pl = $('<p class="addMeta"></p>');
+      const pl = $('<p class="addMeta"></p>');
 
       $(target).find('.addMeta').remove();
@@ -165,11 +165,10 @@
       if ($(data).find('meta').length > 0) {
         pl.empty();
-        var meta_link;
 
         $(data).find('meta').each(function(i) {
-          meta_link = $('<button type="button" class="metaItem meta-helper">' + $(this).text() + '</button>');
+          const meta_link = $('<button type="button" class="metaItem meta-helper">' + $(this).text() + '</button>');
           meta_link.get(0).meta_id = $(this).text();
           meta_link.click(function() {
-            var v = This.splitMetaValues(This.meta_dialog.val() + ',' + this.meta_id);
+            const v = This.splitMetaValues(This.meta_dialog.val() + ',' + this.meta_id);
             This.meta_dialog.val(v.join(','));
             return false;
@@ -183,5 +182,5 @@
 
         if (list_type == 'more') {
-          var a_more = $('<button type="button" class="button metaGetMore meta-helper"></button>');
+          const a_more = $('<button type="button" class="button metaGetMore meta-helper"></button>');
           a_more.append(This.text_all + String.fromCharCode(160) + String.fromCharCode(187));
           a_more.click(function() {
@@ -195,8 +194,8 @@
           pl.addClass('hide');
 
-          var pa = $('<p></p>');
+          const pa = $('<p></p>');
           target.append(pa);
 
-          var a = $('<button type="button" class="button metaGetList meta-helper">' + This.text_choose + '</button>');
+          const a = $(`<button type="button" class="button metaGetList meta-helper">${This.text_choose}</button>`);
           a.click(function() {
             $(this).parent().next().removeClass('hide');
@@ -225,5 +224,5 @@
       this.displayMetaList();
     } else {
-      var params = {
+      const params = {
         xd_check: dotclear.nonce,
         f: 'setPostMeta',
@@ -233,5 +232,5 @@
       };
 
-      var This = this;
+      const This = this;
       $.post(this.service_uri, params, function(data) {
         if ($(data).find('rsp').attr('status') == 'ok') {
@@ -247,6 +246,6 @@
   removeMeta: function(meta_id) {
     if (this.post_id == false) {
-      var meta = this.splitMetaValues(this.meta_field.val());
-      for (var i = 0; i < meta.length; i++) {
+      let meta = this.splitMetaValues(this.meta_field.val());
+      for (let i = 0; i < meta.length; i++) {
         if (meta[i] == meta_id) {
           meta.splice(i, 1);
@@ -257,9 +256,9 @@
       this.displayMetaList();
     } else {
-      var text_confirm_msg = this.text_confirm_remove.replace(/%s/, this.meta_type);
+      const text_confirm_msg = this.text_confirm_remove.replace(/%s/, this.meta_type);
 
       if (window.confirm(text_confirm_msg)) {
-        var This = this;
-        var params = {
+        const This = this;
+        const params = {
           xd_check: dotclear.nonce,
           f: 'delMeta',
@@ -290,8 +289,8 @@
     }
 
-    var res = [];
-    var v = str.split(',');
+    let res = [];
+    let v = str.split(',');
     v.sort();
-    for (var i = 0; i < v.length; i++) {
+    for (let i = 0; i < v.length; i++) {
       v[i] = v[i].replace(/^\s*/, '').replace(/\s*$/, '');
       if (v[i] != '' && !inArray(v[i], res)) {
Index: admin/js/services.js
===================================================================
--- admin/js/services.js	(revision 3880)
+++ admin/js/services.js	(revision 3880)
@@ -0,0 +1,174 @@
+/*global $, dotclear */
+'use strict';
+
+/**
+ * Gets the entry (post, page, …) content.
+ *
+ * @param      numeric     postId    The post identifier
+ * @param      function    callback  The callback
+ * @param      object      options   The options
+ */
+dotclear.getEntryContent = function(postId, callback, options) {
+  let res = '';
+  const opt = $.extend({
+    // Entry type (default: post)
+    type: '',
+    // Alert on error
+    alert: true,
+    // Clean content (useful for potential XSS in spam)
+    clean: false,
+    // Cut content after length chars (-1 to not cut)
+    length: -1,
+  }, options);
+
+  // Check callback fn()
+  if (!$.isFunction(callback)) {
+    return;
+  }
+
+  // Get entry content
+  $.get('services.php', {
+      f: 'getPostById',
+      id: postId,
+      post_type: opt.type,
+      xd_check: dotclear.nonce
+    })
+    .done(function(data) {
+      // Response received
+      const rsp = $(data).children('rsp')[0];
+      if (rsp.attributes[0].value == 'ok') {
+        let excerpt = $(rsp).find('post_display_excerpt').text();
+        let content = $(rsp).find('post_display_content').text();
+        if (excerpt || content) {
+          // Clean content if requested
+          if (opt.clean) {
+            const text = document.createElement('textarea');
+            if (excerpt) {
+              text.textContent = excerpt;
+              excerpt = text.innerHTML;
+            }
+            if (content) {
+              text.textContent = content;
+              content = text.innerHTML;
+            }
+          }
+          // Compose full content
+          if (!opt.clean) {
+            content = (excerpt ? `${excerpt}<hr />` : '') + content;
+          }
+          // Cut content if requested
+          if (opt.length > -1) {
+            content = content.substr(0, opt.length);
+          }
+          if (opt.clean && content) {
+            content = `<pre>${content}</pre>`;
+          }
+          res = content;
+        }
+      } else {
+        if (opt.alert) {
+          window.alert($(rsp).find('message').text());
+        }
+      }
+    })
+    .fail(function(jqXHR, textStatus, errorThrown) {
+      // No response
+      window.console.log(`AJAX ${textStatus} (status: ${jqXHR.status} ${errorThrown})`);
+      if (opt.alert) {
+        window.alert('Server error');
+      }
+    })
+    .always(function() {
+      // Finally
+      callback(res);
+    });
+};
+
+/**
+ * Gets the comment content.
+ *
+ * @param      numeric     commentId  The comment identifier
+ * @param      function    callback   The callback
+ * @param      object      options    The options
+ */
+dotclear.getCommentContent = function(commentId, callback, options) {
+  let res = '';
+  const opt = $.extend({
+    // Get comment metadata (email, site, …)
+    metadata: true,
+    // Show IP in metadata
+    ip: true,
+    // Alert on error
+    alert: true,
+    // Clean content (useful for potential XSS in spam)
+    clean: false,
+    // Cut content after length chars (-1 to not cut)
+    length: -1,
+  }, options);
+
+  // Check callback fn()
+  if (!$.isFunction(callback)) {
+    return;
+  }
+
+  // Get comment content
+  $.get('services.php', {
+      f: 'getCommentById',
+      id: commentId,
+      xd_check: dotclear.nonce
+    })
+    .done(function(data) {
+      // Response received
+      const rsp = $(data).children('rsp')[0];
+      if (rsp.attributes[0].value == 'ok') {
+        let content = $(rsp).find('comment_display_content').text();
+        if (content) {
+          // Clean content if requested
+          if (opt.clean) {
+            const text = document.createElement('textarea');
+            text.textContent = content;
+            content = text.innerHTML;
+          }
+          // Cut content if requested
+          if (opt.length > -1) {
+            content = content.substr(0, opt.length);
+          }
+          if (opt.clean && content) {
+            content = `<pre>${content}</pre>`;
+          }
+          // Get metadata (if requested)
+          if (opt.metadata) {
+            const comment_email = $(rsp).find('comment_email').text();
+            const comment_site = $(rsp).find('comment_site').text();
+            const comment_ip = $(rsp).find('comment_ip').text();
+            const comment_spam_disp = $(rsp).find('comment_spam_disp').text();
+
+            content += `<p>
+              <strong>${dotclear.msg.website}</strong> ${comment_site}<br />
+              <strong>${dotclear.msg.email}</strong> ${comment_email}`;
+            if (opt.ip) {
+              content += `<br />
+                <strong>${dotclear.msg.ip_address}</strong> <a href="comments.php?ip=${comment_ip}">${comment_ip}</a>`;
+            }
+            content += `</p>${comment_spam_disp}`;
+          }
+          res = content;
+        }
+      } else {
+        if (opt.alert) {
+          window.alert($(rsp).find('message').text());
+        }
+      }
+    })
+    .fail(function(jqXHR, textStatus, errorThrown) {
+      // No response
+      window.console.log(`AJAX ${textStatus} (status: ${jqXHR.status} ${errorThrown})`);
+      if (opt.alert) {
+        window.alert('Server error');
+      }
+    })
+    .always(function() {
+      // Finally
+      callback(res);
+    });
+};
Index: admin/langs.php
===================================================================
--- admin/langs.php	(revision 3731)
+++ admin/langs.php	(revision 3874)
@@ -158,8 +158,8 @@
     dcPage::jsLoad('js/_langs.js'),
     dcPage::breadcrumb(
-        array(
+        [
             __('System')               => '',
             __('Languages management') => ''
-        ))
+        ])
 );
 
@@ -183,5 +183,5 @@
 
 $locales_content = scandir(DC_L10N_ROOT);
-$tmp             = array();
+$tmp             = [];
 foreach ($locales_content as $v) {
     $c = ($v == '.' || $v == '..' || $v == 'en' || !is_dir(DC_L10N_ROOT . '/' . $v) || !isset($iso_codes[$v]));
@@ -217,5 +217,5 @@
             '<div>' .
             $core->formNonce() .
-            form::hidden(array('locale_id'), html::escapeHTML($k)) .
+            form::hidden(['locale_id'], html::escapeHTML($k)) .
             '<input type="submit" class="delete" name="delete" value="' . __('Delete') . '" /> ' .
                 '</div>' .
@@ -236,5 +236,5 @@
 
 if (!empty($dc_langs) && $is_writable) {
-    $dc_langs_combo = array();
+    $dc_langs_combo = [];
     foreach ($dc_langs as $k => $v) {
         if ($v->link && isset($iso_codes[$v->title])) {
@@ -249,10 +249,10 @@
         'Proposed languages are based on your version: %s.'), '<strong>' . DC_VERSION . '</strong>') . '</p>' .
     '<p class="field"><label for="pkg_url" class="classic">' . __('Language:') . '</label> ' .
-    form::combo(array('pkg_url'), $dc_langs_combo) . '</p>' .
+    form::combo(['pkg_url'], $dc_langs_combo) . '</p>' .
     '<p class="field"><label for="your_pwd1" class="classic required"><abbr title="' . __('Required field') . '">*</abbr> ' . __('Your password:') . '</label> ' .
-    form::password(array('your_pwd', 'your_pwd1'), 20, 255,
-        array(
+    form::password(['your_pwd', 'your_pwd1'], 20, 255,
+        [
             'extra_html'   => 'required placeholder="' . __('Password') . '"',
-            'autocomplete' => 'current-password')
+            'autocomplete' => 'current-password']
     ) . '</p>' .
     '<p><input type="submit" value="' . __('Install language') . '" />' .
@@ -271,8 +271,8 @@
     '<input type="file" id="pkg_file" name="pkg_file" required /></p>' .
     '<p class="field"><label for="your_pwd2" class="classic required"><abbr title="' . __('Required field') . '">*</abbr> ' . __('Your password:') . '</label> ' .
-    form::password(array('your_pwd', 'your_pwd2'), 20, 255,
-        array(
+    form::password(['your_pwd', 'your_pwd2'], 20, 255,
+        [
             'extra_html'   => 'required placeholder="' . __('Password') . '"',
-            'autocomplete' => 'current-password')
+            'autocomplete' => 'current-password']
     ) . '</p>' .
     '<p><input type="submit" name="upload_pkg" value="' . __('Upload language') . '" />' .
